#!/usr/bin/perl
##############################################################################
#
#  ETS -- Wolfenstein: Enemy Territory Statistics
#  (c) Vladi Shabanski <cade@bis.bg> 2003
#  http://soul.datamax.bg/~cade/away/ets
#
#  Developed for play.evrocom.net server ET community
#  http://play.evrocom.net
#
#  This software is distributed under GPL license, see COPYING for details.
#
#  $Id: ets.pl,v 1.13 2003/07/22 07:44:17 cade Exp $
#
##############################################################################
use Data::Dumper;
use strict;

###CONFIG#####################################################################

our $FLOOR = 50;

my $html_header = "<html>
        <meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
        <title>Wolfenstein: Enemy Territory Statistics</title>
        <style>
        <!--
        BODY  { margin: 0px 0px 0px 0px; color: #fff;
                background-color: #111;
                background-image: url(etback2.jpg);
                background-repeat: no-repeat;
                background-position top center;
                background-attachment: fixed; }
        TABLE { font-family: monospace; background-color: #888; white-space: pre; }
        TR.hh { border: solid 1px #aaa; background-color: #777; font-weight: bold; }
        TR.ff { border: solid 1px #aaa; background-color: #777; font-weight: bold; }
        TR.cc { border: solid 1px #aaa; background-color: #445; text-color: #aaa; }
        TR.r1 { border: solid 1px #aaa; background-color: #444; }
        TR.r2 { border: solid 1px #aaa; background-color: #555; }
        A     { font-family: monospace; color: #0ff; text-decoration: none; }
        -->
        </style>
        <center>
        <p>
        <h1>Wolfenstein: Enemy Territory Statistics</h1>
        <h2>[ENV:ETS_SERVER]</h2>
        <small>This page is created at [TIME]</small>
        <p>
        |
        <a href=games.html>last games</a> |
        <a href=score.html>top scores</a> |
        <a href=kil.html>kills</a> |
        <a href=ded.html>deaths</a> |
        <a href=kdr.html>k/d ratio</a> |
        <a href=players.html>players (long!)</a> |
        <a href=classide.html>sides/classes</a> |
        <br>
        |
        <a href=wep.html>weapons</a> |
        <a href=uniforms.html>uniforms/disguise</a> |
        <a href=kpm.html>top kills per minute</a> |
        <a href=noise.html>noise</a> |
        <a href=waste.html>time waste</a> |
        <br>
        |
        <a href=p_soldier.html>soldier</a> |
        <a href=p_medic.html>medic</a> |
        <a href=p_engineer.html>engineer</a> |
        <a href=p_field_ops.html>field_ops</a> |
        <a href=p_covert_ops.html>covert_ops</a> |
        <br>
        |
        <a href=p_axis.html>axis</a> |
        <a href=p_allies.html>allies</a> |
        <p>
        ";

my $html_footer = "<p>
       <small>
       Note: Limit is set to top $FLOOR entries (the rest are counted but not shown).<p>
       Thanks to all players at <a href=http://play.evrocom.net>http://play.evrocom.net</a>!<br>
       <a href=http://soul.datamax.bg/~cade/away/ets><b>ETS</b></a> by (c) <a href=mailto:cade\@bis.bg>&lt;cade\@bis.bg&gt;</a> 2003
       </small>
       </center>
       </html>";

my $html_motd = "<h2>Welcome to server statistics page for play.evrocom.net!</h2>";

###STATIC#####################################################################

my %CLASS = (
             0 => 'SOLDIER',
             1 => 'MEDIC',
             2 => 'ENGINEER',
             3 => 'FIELD_OPS',
             4 => 'COVERT_OPS',
            );
            
my %SIDE  = (
             0 => 'UNKNOWN',
             1 => 'AXIS',
             2 => 'ALLIES',
             3 => 'SPECTATORS',
            );            
my %WEAPON = (
             0 => 'KNIFE',
             1 => 'LUGER',
             2 => 'COLT',             #  8
             3 => 'MP40',             #  9
             4 => 'THOMPSON',         # 10
             5 => 'STEN',             # 11
             6 => 'FG42',             # 15
             7 => 'PANZERFAUST',
             8 => 'FLAMETHROWER',
             9 => 'GRENADE',
            10 => 'MORTAR',
            11 => 'DYNAMITE',         # 26
            12 => 'AIRSTRIKE',        # 28
            13 => 'ARTY',             # 30
            14 => 'SYRINGE',
            15 => 'SMOKECAN',
            16 => 'SATCHEL',
            17 => 'GRENADE_LAUNCHER', # 18
            18 => 'LANDMINE',         # 45
            19 => 'MOBILE_MG42',
            20 => 'GARAND',
            21 => 'KAR98'
            );
my %WEAPON_REV = reverse %WEAPON;            

my %SKILL = (
             0 => 'BATTLE SENSE',             
             1 => 'ENGINEERING',             
             2 => 'FIRST AID',             
             3 => 'SIGNALS',             
             4 => 'LIGHT WEAPONS',             
             5 => 'HEAVY WEAPONS',             
             6 => 'COVERT OPS',             
            );
            
# thanx, furiozo :)
my %COLOR = (
            '1' => 'f70400',
            '2' => '02f702',
            '3' => 'fdf900',
            '4' => '0006f8',
            '5' => '00f6f3',
            '6' => 'f407f5',
            '7' => 'f9f9f9',
            '8' => 'ff7b06',
            '9' => '7c7d81',
            '0' => '000100',
            'q' => 'f70303',
            ')' => 'f70303',
            'w' => 'f4f6f1',
            'e' => '8100fd',
            'r' => '00f904',
            't' => '0005f4',
            'y' => '7b7d7a',
            'u' => '00faf6',
            'i' => 'fb0033',
            'o' => 'eff174',
            'p' => '060702',
            'a' => 'fd9534',
            's' => 'fbf904',
            'd' => '007dfe',
            'f' => '3795c8',
            '&' => '3795c8',
            'g' => 'c2fcc9',
            'h' => '066432',
            '(' => '066432',
            'j' => 'ad1c17',
            'k' => '9b3107',
            'l' => 'cf9834',
            ';' => 'c0bfc7',
            'z' => 'bcbdc2',
            'x' => 'f98000',
            'c' => '7b0484',
            'v' => 'f900f9',
            'b' => '037d7e',
            'n' => 'faf9c0',
            'm' => '9b9935',
            ',' => 'cf9a3a',
            '.' => 'f7f8b6',
            '/' => 'fbfc7c',
            '-' => '98972d',
            '=' => '7f7f00',
            '\\' => '007f03',
            '[' => 'bec0bb',
            ']' => '7f7c0b',
            '\'' => 'c5f9c8',
            '*' => 'ae181a',
            );

###MAIN#######################################################################

die "usage: $0 log-file html-output-dir\n" unless @ARGV == 2;

my $log_file = shift;
my $html_dir = shift;

my %gun;

my %kil;
my %ded;
my %kil2;
my %ded2;

my %wep;  # wepon usage by weapon -> count
my %wep2; # weapon usage by players/clans -> weapon
my %wep3; # weapon usage by weapons -> player/clan

my %score_tmp;  # temp array player -> [ scores ]
my %score_ave;  # average
my %score_med;  # median
my %score_sum;  # total/sum


my %nam;
my %nam_color;

my %kdr;  # kill/death ratio

my %unif_taken; # uniforms taken
my %unif_lost; # uniforms lost

my %noise; # noise in words :)

my %class_last; # last classes per player
my %class; # classes per player

my %side_last; # last side per player
my %side; # side per player

my %global_class;
my %global_side;

my %classes;
my %sides;

my %client; # clients info

my $href = 0;
my %href;

my $minute; # used for top kills per minute
my %kpm_temp;
my %kpm;

my %conn_time;  # connect time
my %time_waste; # time "wasted" :)

my %game;  # game statistics
my @games; # all games

my %player; # stats from weapon stats, same as in @games

#-----------------------------------------------------------------------------

setpriority( 0, 0, 19 );

my $time_base = 0;
my $local_time = 0;
my $last_local_time = 0;
my $time = 0;

my %last_server;
my $exit = 0;

print STDERR "processing log file: $log_file\n";

open( my $i, $log_file ) or die "$0: cannot open log file: $log_file\n";
while(<$i>)
  {
  next if /^[\s\r\n]*$/;
  s/<world>/*WORLD*/gi;
  s/^\s*(\d+):(\d+)\s*//; # get time
  $local_time = $1 * 60 + $2;
  if( $last_local_time > $local_time )
    {
    $time_base = $time_base + $last_local_time;
    }
  $last_local_time = $local_time;
  $time_base = $1 if /^TIME:(\d+)/; # get time base
  $time = $time_base + $local_time;
  $minute = $time - $time % 60;
  my $time_str = scalar localtime( $time );
  $time_str =~ s/  / 0/;

#print STDERR "$time_str ($time) [$time_base:$local_time] $_";

  if( /^ClientConnect: (\d+)/i )
    {
    #print STDERR "c: $1\n";
    next if exists $conn_time{ $1 };
    $conn_time{ $1 } = $time;
    next;
    }
  if( /^ClientDisconnect: (\d+)/i )
    {
    next unless exists $conn_time{ $1 };
    my $wasted = int( $time - $conn_time{ $1 } );
    delete $conn_time{ $1 };
    my $name = $client{ $1 }{ 'n' };
    #print STDERR "d: $1 ($name) $wasted\n";
    next if $name eq ''; # anonymous
    $time_waste{ $name } += $wasted;
    $time_waste{ get_clan( $name ) } += $wasted;
    next;
    }
  if( /^ShutdownGame:/ )
    {
    for my $k ( keys %conn_time )
      {
      my $wasted = int( $time - $conn_time{ $k } );
      my $name = $client{ $k }{ 'n' };
      next if $name eq '';
      $time_waste{ $name } += $wasted;
      $time_waste{ get_clan( $name ) } += $wasted;
      #print STDERR "d: $k ($name) $wasted\n";
      }
    %conn_time = ();  
    # next; # nadolu ima oshte edin handler za shutdown game
    }
  if( /^ClientUserinfoChanged: (\d+) (.+)/i )
    {
    # n\xwayBG\t\2\c\4\r\0\m\0000000\s\0000000\dn\chromosome\dr\0\w\10\lw\10\sw\41\mu\0\ref\0
    my $id = $1;
    my $data = $2;
    $client{ $id } = { split /\\/, $data };
    
    my $name = $client{ $id }{ 'n' };
    $name =~ s/\^.//g; # clear colors etc.
    $nam_color{ $name } = $client{ $id }{ 'n' } if $name ne $client{ $id }{ 'n' };
    $client{ $id }{ 'n' } = $name;
    $client{ $id }{ 'dn' } =~ s/\^.//g; # clear colors etc.

    my $dn = $client{ $id }{ 'dn' };
    my $class = $CLASS{ $client{ $id }{ 'c' } };
    my $side = $SIDE{ $client{ $id }{ 't' } };
    if( $dn )
      {
      $unif_taken{ $name }++;
      $unif_lost{ $dn }++;
      };
    if( $class_last{ $name } ne $class )
      {
      $class{ $name }{ $class }++;
      $class{ get_clan( $name ) }{ $class }++;
      $class_last{ $name } = $class;
      $global_class{ $class }++;
      $classes{ $class }{ $name }++;
      $classes{ $class }{ get_clan( $name ) }++;
      }
    if( $side_last{ $name } ne $side )
      {
      $side{ $name }{ $side }++;
      $side{ get_clan( $name ) }{ $side }++;
      $side_last{ $name } = $side;
      $global_side{ $side }++;
      $sides{ $side }{ $name }++;
      $sides{ $side }{ get_clan( $name ) }++;
      }
    next;
    }
  s/\^.//g; # clear colors etc. this is after ClientUserinfoChanged to preserve original names
  if( /WeaponStats:\s*(.+)$/ )
    {
    my %data = parse_weaponstats( $1 );
    $game{ $data{ 'PLAYER' } } = \%data;
    next;
    }
  if( /^InitGame:\s*(.*)$/ )
    {
    $exit = 0;
    %game = ();
    %last_server = split /\\/, "\\$1";
    next;
    }
  if( /Exit:/ )
    {
    $exit = 1;
    }
  if( /^ShutdownGame/ and $exit )
    {
    my @players = keys %game;
    my $pc = scalar @players;
    if( $pc > 0 )
      {
      push @games, { 'STATS' => { %game },
                     'TIME' => $time, 
                     'PLAYERS' => $pc,
                     'MAP' => $last_server{ 'mapname' },
                      };
      }                
    %game = ();
    next;
    }  
  if( /Kill: (\d+) (\d+) (\d+): (.+) killed (.+) by MOD_([A-Z_0-9]+)/i )
    {
    $gun{ $3 } |= $6;
    
    $kpm_temp{ $4 }{ $minute }++;
    $kpm_temp{ get_clan( $4 ) }{ $minute }++;
    
    die "mismatched gun name: $6" if $gun{ $3 } ne $6;
    
    # kills
    $kil{ $4 }++;
    $kil{ get_clan( $4 ) }++;
    $kil2{ $4 }{ $5 }++;
    $kil2{ get_clan( $4 ) }{ get_clan( $5 ) }++;
    
    # deaths
    $ded{ $5 }++;
    $ded{ get_clan( $5 ) }++;
    $ded2{ $5 }{ $4 }++;
    $ded2{ get_clan( $5 ) }{ get_clan( $4 ) }++;
    
    # weapon usage
    $wep{ $6 }++;
    $wep2{ $4 }{ $6 }++;
    $wep2{ get_clan( $4 ) }{ $6 }++;
    $wep3{ $6 }{ $4 }++;
    $wep3{ $6 }{ get_clan( $4 ) }++;
    
    # get names...
    $nam{ $4 }++;
    $nam{ $5 }++;
    $nam{ get_clan( $4 ) }++;
    $nam{ get_clan( $5 ) }++;

    #print STDERR "unknown: $_\n" if $6 eq '';
    next;
    }
  if( /^say(team)?: ([^:]+): (.+)/i )
    {
    my $p = $2;
    my $cnt = $3 =~ /\S+/g;
    $noise{ $p } += $cnt;
    $noise{ get_clan( $p ) } += $cnt;
    next;
    }
  if( /^score: +(\d+) +ping: +(\d+) +client: (\d+) (.+)/ )
    {
    my $clan = get_clan( $4 );
    $score_tmp{ $4 } = [] unless $score_tmp{ $4 };
    $score_tmp{ $clan } = [] unless $score_tmp{ $clan };
    
    push @{ $score_tmp{ $4 } }, $1;
    push @{ $score_tmp{ $clan } }, $1;
    
    next;
    }
  #if( /?? end/start of game ??/ )
  #  {
  #  %class_last = ();
  #  %side_last = ();
  #  next;
  #  }  
  }
close($i);

print STDERR "done (end virtual time is $time)\n";

#-----------------------------------------------------------------------------

print STDERR "processing data...\n";

$nam_color{ 'AXIS' } = "^1AXIS";
$nam_color{ 'ALLIES' } = "^4ALLIES";
$nam_color{ 'SPECTATORS' } = "^2SPECTATORS";

# fix names links
for my $k ( keys %nam )
  {
  my $k2 = $k;
  $k2 =~ s/[^!a-z0-9\-\_]/_/gi;
  $href{ $k } = lc $k2;
  }

# calc things  
for my $p ( keys %nam )
  {
  my $k = $kil{ $p } || 0;
  my $d = $ded{ $p } || 0;
  my $r = $d > 0 ? sprintf "%.2f", $k / $d : 'n/a'; #'

  $kdr{ $p } = $r;
  }

while( my ( $k, $v ) = each %kpm_temp )
  {
  my ( $max_k, $max_v ) = hash_max( $v );
  # $k = sprintf "%s  %s", scalar localtime( $max_k ), color_name( $k );
  $kpm{ $k } = $max_v;
  }

while( my ( $k, $v ) = each %score_tmp )
  {
  my $sum = 0;
  $sum += $_ for @$v;
  @$v = sort @$v;
  my $med = $$v[@$v/2];
  
  $score_ave{ $k } = int( $sum / @$v );
  $score_med{ $k } = $med;
  $score_sum{ $k } = $sum;
  }

print STDERR "done\n";

#-----------------------------------------------------------------------------

my @games_text;

push @games_text, [ 'HEAD', '[>]#', 'Map', '[>]Players', 'Finish Time' ];
@games = reverse @games;
my $gc = 0; # game counter
for my $gr ( @games )
  {
  my $ti = $gr->{ 'TIME' };
  my $ma = $gr->{ 'MAP' };
  my $tm = localtime( $ti );
  push @games_text, [ '', '(ROW)', $ma, $gr->{ 'PLAYERS' }, "<a href=game_$ti.html>$tm</a>" ];
  html_save( "game_$ti", "<h2>game at $tm on $ma map</h2>",
                         # single_game_stats( $gr, TYPE => 'SHOTS' ),
                         single_game_stats( $gr, TYPE => 'SHOTS', SIDE => 'ALLIES' ),
                         single_game_stats( $gr, TYPE => 'SHOTS', SIDE => 'AXIS' ),
                         # single_game_stats( $gr, TYPE => 'DAMAGE' ),
                         single_game_stats( $gr, TYPE => 'DAMAGE', SIDE => 'ALLIES' ),
                         single_game_stats( $gr, TYPE => 'DAMAGE', SIDE => 'AXIS' ),
                         single_game_stats( $gr, TYPE => 'DETAILS' ) );
  $gc++;
  }

html_save( 'index', $html_motd );
html_save( 'games', $html_motd, "<p><h2>Last games: (approx. last 24 hours)</h2><p>", 
                                html_table( [ grep /\S/, @games_text[0..50] ] ), 
                                "<p><a href=games_all.html>show all $gc games (long!)</a>" );
html_save( 'games_all',         $html_motd . "<p><h2>All $gc games</h2><p>" . html_table( \@games_text ) );

html_save( 'players',     mod_player_clan_stats( CLAN => 1, SORT => 'PLR', FLOOR => 1_000_000 ),
                          mod_player_clan_stats( CLAN => 0, SORT => 'PLR', FLOOR => 1_000_000 ) );

html_save( 'kil',         "<p><h2>top kills</h2><p>",
                          mod_player_clan_stats( CLAN => 1, SORT => 'KIL' ), 
                          mod_player_clan_stats( CLAN => 0, SORT => 'KIL' ) );
html_save( 'ded',         "<p><h2>top deaths</h2><p>",
                          mod_player_clan_stats( CLAN => 1, SORT => 'DED' ), 
                          mod_player_clan_stats( CLAN => 0, SORT => 'DED' ) );
html_save( 'kdr',         "<p><h2>top kills/deaths ratio</h2><p>",
                          mod_player_clan_stats( CLAN => 1, SORT => 'KDR' ), 
                          mod_player_clan_stats( CLAN => 0, SORT => 'KDR' ) );

for my $k ( keys %classes )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_hash_stats( "$k (totals per clan)", $classes{ $k }, CLAN => 1 ),
                               mod_hash_stats( "$k", $classes{ $k } ) );
  }
for my $k ( keys %sides )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_hash_stats( "$k (totals per clan)", $sides{ $k }, CLAN => 1 ),
                               mod_hash_stats( "$k", $sides{ $k } ) );
  }
for my $k ( keys %wep3 )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_hash_stats( "weapon $k used by clan:", $wep3{ $k }, CLAN => 1, HEAD => "#,Clan,Kills,Percentage" ),
                               mod_hash_stats( "weapon $k used by player:", $wep3{ $k }, HEAD => "#,Player,Kills,Percentage" ) );
  }
for my $k ( sort { $kil{ $b } <=> $kil{ $a } } keys %nam )
  {
  my $text;
  my $clan = 0;
  if( $k =~ /^!/ )
    {
    #$text .= mod_hash_stats( "clan members and total scores for " . color_name( $k ), $score_clan{ $k } );
    $clan = 1;
    };
  $text .= mod_hash_stats( "sides played by " . color_name( $k ), $side{ $k } );
  $text .= mod_hash_stats( "classes played by " . color_name( $k ), $class{ $k } );
  #$text .= mod_hash_stats( "preferred weapons by " . color_name( $k ), $wep2{ $k }, HEAD => "#,Weapon,Kills,Percentage" );
  $text .= mod_weapons_stats( "weapons statistics for " . color_name( $k ), $k );
  #$text .= mod_hash_stats( "top scores and last classes for " . color_name( $k ) . ", median.average is " . $score_av{ $k }, $scores{ $k } );
  #$text .= mod_hash_stats( color_name( $k ) . " killed: ", $kil2{ $k }, CLAN => $clan );
  #$text .= mod_hash_stats( color_name( $k ) . " was killed by: ", $ded2{ $k }, CLAN => $clan );
  $text .= mod_kill_killed( "public relations for " . color_name( $k ), $k );
  
  html_save( 'p_' . $href{$k}, $text );
  }

#html_save( 'kdr',      mod_hash_stats( "kill/death ratio by clans", \%kdr, NOP => 1, CLAN => 1 ),
#                       mod_hash_stats( "kill/death ratio by players", \%kdr, NOP => 1 ) );

html_save( 'noise',    mod_hash_stats( "noise in words by clan", \%noise, CLAN => 1 ),
                       mod_hash_stats( "noise in words by player", \%noise ) );

html_save( 'uniforms', mod_hash_stats( "uniforms taken", \%unif_taken ),
                       mod_hash_stats( "uniforms lost", \%unif_lost ) );

html_save( 'kpm',      mod_hash_stats( "top kills per minute by clan",   \%kpm, NOP => 1, CLAN => 1 ),
                       mod_hash_stats( "top kills per minute by player", \%kpm, NOP => 1 ) );

html_save( 'waste',    mod_hash_stats( "time wasted by clan",   \%time_waste, TIMEFMT => 1, CLAN => 1, HEAD => "#,Player,Time,Percentage" ),
                       mod_hash_stats( "time wasted by player", \%time_waste, TIMEFMT => 1,  HEAD => "#,Clan,Time,Percentage" ) );

html_save( 'classide', mod_hash_stats( "sides played", \%global_side ),
                       mod_hash_stats( "classes played", \%global_class ) );

html_save( 'wep', mod_hash_stats( "preferred weapons", \%wep, HEAD => "#,Weapon,Kills,Percentage" ) );

#html_save( 'score', mod_hash_stats( "median.average score by clan", \%score_av, NOP => 1, CLAN => 1, HEAD => "#,Clan,Median.Average Score,Percentage" ),
#                    mod_hash_stats( "median.average score by player", \%score_av, NOP => 1, HEAD => "#,Player,Median.Average Score,Percentage" ),
#                    mod_hash_stats( "score by clan", \%score, CLAN => 1, HEAD => "#,Clan,Score,Percentage" ),
#                    mod_hash_stats( "score by player", \%score, HEAD => "#,Player,Score,Percentage" ) );

html_save( 'score', mod_score_stats( "scores by clan", CLAN => 1 ),
                    mod_score_stats( "scores by player", CLAN => 0 ) );

##############################################################################

sub mod_score_stats
{
  my $title = shift;
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };
  
  my @data;

  my @p = keys %nam;
  @p = grep /^!/, @p if $clan;
  @p = grep ! /^!/, @p if ! $clan;
  @p = sort { $score_med{ $b } <=> $score_med{ $a } } @p;
  
  push @data, [ 'HEAD', "[>5%]#", "[45%]Player/Clan", "[>10%]Rounds", "[>10%]Median Score", "[>10%]Average Score", "[>10%]Total Score", "[>10%]Total Score%" ];
  
  my $sum = hash_sum( \%score_sum );
  my $r = 0;
  for my $p ( @p )
    {
    last if $r++ == $FLOOR;                                  
    my $pc = color_name( $p );
    my $sump = $sum > 0 ? ( 100 * $score_sum{ $p } ) / $sum : 0;
    push @data, [ '', "(ROW)", "<a href=p_$href{$p}.html>$pc</a>", 
                               $score_tmp{ $p } ? scalar @{ $score_tmp{ $p } } : 0,
                               $score_med{ $p }, 
                               $score_ave{ $p }, 
                               $score_sum{ $p },
                               "$sump/p"
                               ];
    }

  push @data, [ 'FOOT', "", "Total:", "(SUM)/i", "", "", "(SUM)/i", '' ];
  
  return "<h2>$title</h2>" . html_table( \@data );
}

sub mod_player_clan_stats
{
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };
  my $sort = $opt{ 'SORT' } || 'KIL';

  my @data;

  my $text;
  
  $text .= "<p>";
  $text .= $clan ? "<h2>Clans</h2>" : "<h2>Players</h2>";

  push @data, [ 'HEAD', "[>5%]#", "[15%]Clan", "[30%]Player", "[>10%]Kills", "[>10%]Deaths", "[>10%]K/D", "[>20%]Preferred Weapon" ];
  splice( @{$data[-1]}, 2, 2, 'Clan' ) if $clan;
  
  my @p = keys %nam;
  @p = sort { $kil{ $b } <=> $kil{ $a } } @p;
  @p = sort { $ded{ $b } <=> $ded{ $a } } @p if $sort eq 'DED';
  @p = sort { $kdr{ $b } <=> $kdr{ $a } } @p if $sort eq 'KDR';
  @p = sort { $a cmp $b } @p if $sort eq 'PLR';
  
  my $row = 0;
  for my $p ( @p )
    {
    next if $clan and $p !~ /^!/;
    next if !$clan and $p =~ /^!/;

    my $k = $kil{ $p } || 0;
    my $d = $ded{ $p } || 0;
    my $r = $kdr{ $p };
    
    my $c = get_clan( $p );
    
    my $target1 = $href{ $c };
    my $target2 = $href{ $p };
    
    $p =~ s/>/&gt;/g;
    $p =~ s/</&lt;/g;
    
    if ( $row < $FLOOR )
      {
      $row++;
      
      my $w;
      ( $w, undef ) = hash_max( $wep2{ $p } );
      $w ||= 'n/a';
      
      my $class = tr_class();
      $p = color_name( $p );
      $c = color_name( $c );
      push @data, [ '', '(ROW)', "<a href=p_$target1.html>$c</a>",
                                "<a href=p_$target2.html>$p</a>",
                                $k, $d, $r,
                                "<a href=wep.html>$w</a>"];
      splice( @{$data[-1]}, 2, 1 ) if $clan;
      }
    }
  push @data, [ 'FOOT', '', '', 'Totals:', '(SUM)', '(SUM)', '', '' ];
  splice( @{$data[-1]}, 2, 1 ) if $clan;
  $text .= html_table( \@data );
  $text .= "\n\n\n\n";
  return $text;
}

##############################################################################

sub single_game_stats
{
  my $gr = shift; # game hash reference
  my %opt = @_;
  
  my $side = $opt{ 'SIDE' };
  my $type = $opt{ 'TYPE' };
  
  my $game = $gr->{ 'STATS' };
  
  my $text;
  
  #$text .= Dumper( $gr );
  #$text = "<pre>$text</pre>";
  
  my @data_w;
  my @data_d;

  push @data_w, [ 'HEAD', '[>]#', '[30%]Player', 'Side', '[>]Shots', '[>]Hits', '[>]Head', '[>]Kills', '[>]Deaths', '[>]Acc.%', '[>]HeadAcc.%', ];
  push @data_d, [ 'HEAD', '[>]#', '[30%]Player', 'Side', '[>]Damage Given', '[>]Damage Received', '[>]Team Damage', ];

  my @p = keys %$game;
  @p = grep { $game->{ $_ }{ 'SIDE' } eq 'AXIS' } @p if $side eq 'AXIS';
  @p = grep { $game->{ $_ }{ 'SIDE' } eq 'ALLIES' } @p if $side eq 'ALLIES';
  @p = sort { $game->{ $a }{ 'SIDE' } cmp $game->{ $b }{ 'SIDE' } } @p;
  
  for my $p ( @p )
    {
    my $v = $game->{ $p };
    my $wt = $v->{ 'WEAPONS_TOTALS' };
    my $pc = color_name( $p );
    my $s = lc $v->{ 'SIDE' };
    my $sc = color_name( $v->{ 'SIDE' } );
    push @data_w, [ '', '(ROW)',
                "[<]<a href=p_$href{$p}.html>$pc</a>", 
                "<a href=p_$s.html>$sc</a>",
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                $wt->{ 'K' },
                $wt->{ 'D' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];

    if( $type eq 'DETAILS' )
      {
      for my $w ( sort keys %{ $v->{ 'WEAPONS' } } )
        {
        $wt = $v->{ 'WEAPONS' }{ $w };
        push @data_w, [ 'COMT', '(ROW)',
                    '[>]' . $WEAPON{ $w },
                    "<a href=p_$s.html>$sc</a>",
                    $wt->{ 'S' },
                    $wt->{ 'H' },
                    $wt->{ 'E' },
                    $wt->{ 'K' },
                    $wt->{ 'D' },
                    $wt->{ 'HA' } . '/p',
                    $wt->{ 'EA' } . '/p',
                    ];
        }
      }          
    push @data_d, [ '', '(ROW)',
                "<a href=p_$href{$p}.html>$pc</a>", 
                color_name( $v->{ 'SIDE' } ),
                $v->{ 'DAMAGE' }{ 'SENT' },
                $v->{ 'DAMAGE' }{ 'RECV' },
                $v->{ 'DAMAGE' }{ 'TEAM' },
                ];
    }

  push @data_w, [ 'FOOT', '', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  push @data_d, [ 'FOOT', '', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', ];
  
  $side = color_name( $side );
  $text .= "<h3>$side Shots and accuracy</h3>" . html_table( \@data_w ) if $type eq 'SHOTS';
  $text .= "<h3>$side Damage</h3>" . html_table( \@data_d ) if $type eq 'DAMAGE';
  $text .= "<h3>Detailed Shots and accuracy</h3>" . html_table( \@data_w ) if $type eq 'DETAILS';
  
  return $text;
}

sub mod_weapons_stats
{
  my $title = shift;
  my $p = shift; # player
  my %opt = @_;
  
  return undef unless $player{ $p };
  
  my @data_w;
  
  push @data_w, [ 'HEAD', '[>]#', '[40%]Weapon', '[>]Shots', '[>]Hits', '[>]Head', '[>]Kills', '[>]Deaths', '[>]Acc.%', '[>]HeadAcc.%', ];
  
  for my $w ( sort keys %{ $player{ $p }{ 'WEAPONS' } } )
    {
    my $wt = $player{ $p }{ 'WEAPONS' }{ $w };
    eval 
      {
      $wt->{ 'HA' } = ( 100 * $wt->{ 'H' } ) / $wt->{ 'S' };
      $wt->{ 'EA' } = ( 100 * $wt->{ 'E' } ) / $wt->{ 'S' };
      };
    push @data_w, [ '', '(ROW)',
                $WEAPON{ $w },
                $wt->{ 'S' },
                $wt->{ 'H' },
                $wt->{ 'E' },
                $wt->{ 'K' },
                $wt->{ 'D' },
                $wt->{ 'HA' } . '/p',
                $wt->{ 'EA' } . '/p',
                ];
    }

  push @data_w, [ 'FOOT', '', 'Total:', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(SUM)', '(AVE)/p', '(AVE)/p', ];
  
  return "<h2>$title</h2>" . html_table( \@data_w );
}

##############################################################################

sub parse_weaponstats
{
  my $ws = shift;
  # WeaponStats: 
  # 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5
  my @ws = split /\s+/, $ws;
  
  my %data;
  
  $data{ 'CLIENT' } = shift @ws;
  $data{ 'PLAYER' } = $client{ $data{ 'CLIENT' } }{ 'n' };
  $data{ 'SIDE'   } = $SIDE{ $client{ $data{ 'CLIENT' } }{ 't' } };
  $data{ 'CLASS'  } = $CLASS{ $client{ $data{ 'CLIENT' } }{ 'c' } };
  $data{ 'ROUNDS' } = shift @ws;
  
  my @wep = reverse split //, sprintf '%b', shift @ws;
  my $wc = -1; # weapon counter
  for( @wep )
    {
    $wc++;
    next unless $_;
    
    $data{ 'WEAPONS' }{ $wc }{ 'H' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'S' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'K' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'D' } = shift @ws;
    $data{ 'WEAPONS' }{ $wc }{ 'E' } = shift @ws;
    eval 
      {
      $data{ 'WEAPONS' }{ $wc }{ 'HA' } = ( 100 * $data{ 'WEAPONS' }{ $wc }{ 'H' } ) / $data{ 'WEAPONS' }{ $wc }{ 'S' };
      $data{ 'WEAPONS' }{ $wc }{ 'EA' } = ( 100 * $data{ 'WEAPONS' }{ $wc }{ 'E' } ) / $data{ 'WEAPONS' }{ $wc }{ 'S' };
      };
    }
  for my $w ( keys %{ $data{ 'WEAPONS' } } )
    {
    for my $a ( qw( S H K D E ) )
      {
      $data{ 'WEAPONS_TOTALS' }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      $player{ $data{ 'PLAYER' } }{ 'WEAPONS' }{ $w }{ $a } += $data{ 'WEAPONS' }{ $w }{ $a };
      }
    }  
  eval 
    {
    $data{ 'WEAPONS_TOTALS' }{ 'HA' } = ( 100 * $data{ 'WEAPONS_TOTALS' }{ 'H' } ) / $data{ 'WEAPONS_TOTALS' }{ 'S' };
    $data{ 'WEAPONS_TOTALS' }{ 'EA' } = ( 100 * $data{ 'WEAPONS_TOTALS' }{ 'E' } ) / $data{ 'WEAPONS_TOTALS' }{ 'S' };
    };
  $data{ 'DAMAGE' }{ 'SENT' } = shift @ws;  
  $data{ 'DAMAGE' }{ 'RECV' } = shift @ws;  
  $data{ 'DAMAGE' }{ 'TEAM' } = shift @ws;  
  
  my @ski = split //, sprintf '%b', shift @ws;
  my $sc = -1; # skill counter
  for( @ski )
    {
    $sc++;
    next unless $_;
    $data{ 'SKILL' }{ $sc } = shift @ws;
    }
  return %data;  
}

#----------------------------------------------------------------------------

sub mod_hash_stats
{
  my $title = shift;
  my $hr    = shift;
  my %opt   = @_;
  my $text;

  my $clan = $opt{ 'CLAN' };
  my $tfmt = $opt{ 'TIMEFMT' };
  my $head = $opt{ 'HEAD' };
  
  my $sum = hash_sum( $hr );
  
  my @data;
  
  $text .= "<p>";
  $text .= "<h2>$title</h2>";
  
  push @data, [ 'OPT', "width=05% align=right", "width=40%", "width=30% align=right", "width=25% align=right" ];
  if( $head )
    {
    push @data, [ 'HEAD', split /\s*,\s*/, $head ];
    }
  else
    {  
    push @data, [ 'HEAD', "#", "Name", "Value", "Percentage" ];
    }
  
  my $row = 0;
  for my $k ( sort { $hr->{ $b } <=> $hr->{ $a } } keys %$hr )
    {
    next if $clan and $k !~ /^!/;
    next if !$clan and $k =~ /^!/;
    
    my $v = $hr->{ $k };
    my $p = $sum > 0 ? sprintf "%.2f%%", 100 * $v / $sum : 'n/a'; # '
    
    if( $href{ $k } )
      {
      $k = "<a href=p_$href{$k}.html>".color_name( $k )."</a>";
      }
    else
      {
      $k = color_name( $k );
      }  
    
    $p = 'n/a' if $opt{ 'NOP' };
      
    if ( $row < $FLOOR )
      {
      $row++;
      my $class = tr_class();
      $v = time_fmt( $v ) if $tfmt;
      push @data, [ '', '(ROW)', $k, $v, $p ];
      }        
    }
  $sum = time_fmt( $sum ) if $tfmt;
  if( $opt{ 'NOP' } )
    {
    pop( @$_ ) for ( @data );
    }
  else
    {  
    push @data, [ 'FOOT', '', 'Total:', $sum, '' ];
    }
  $text .= html_table( \@data );
  $text .= "\n\n\n\n";
  return $text;
}

sub mod_kill_killed
{
  my $title = shift;
  my $p = shift; # player
  my %opt = @_;
  
  my @data;
  push @data, [ 'HEAD', "[>5%]#", "[25%]Killed:", "[>10%]Times", "[>10%]%",
                        "[>5%]#", "[25%]Killed by:", "[>10%]Times", "[>10%]%" ];

  my @killed = sort { $kil2{ $p }{ $b } <=> $kil2{ $p }{ $a } } keys %{ $kil2{ $p } };
  my @killby = sort { $ded2{ $p }{ $b } <=> $ded2{ $p }{ $a } } keys %{ $ded2{ $p } };
  
  my $sum_k = hash_sum( $kil2{ $p } );
  my $sum_d = hash_sum( $ded2{ $p } );
  
  my $c = 0;
  while(4)
    {
    my $k = shift @killed;
    my $d = shift @killby;
    
    my $kv = $kil2{ $p }{ $k };
    my $dv = $ded2{ $p }{ $d };
    
    my $kp = $sum_k > 0 ? ( 100 * $kv ) / $sum_k : 0;
    my $dp = $sum_d > 0 ? ( 100 * $dv ) / $sum_d : 0;
    
    my $kc = color_name( $k );
    my $dc = color_name( $d );
    
    push @data, [ '', '(ROW)', "<a href=p_$href{$k}.html>$kc</a>", $kv, "$kp/p",
                      '(ROW)', "<a href=p_$href{$d}.html>$dc</a>", $dv, "$dp/p" ];
    
    last unless @killed or @killby;
    last if ++$c == $FLOOR;
    }
    
  push @data, [ '', '', '', '(SUM)', '',
                    '', '', '(SUM)', '' ];
  
  return "<h2>$title</h2>" . html_table( \@data );
}

#----------------------------------------------------------------------------

sub html_table
{
  my $ar = shift;
  my $text;
  $text .= "<table width=80% cellspacing=1 cellpadding=5>\n";
  my @or; # options row
  my $r = -1; # row
  for my $rr ( @$ar )
    {
    $r++ if $$rr[0] eq '';
    my $c = -1; # column
    my $class = tr_class();
    @or = @$rr and next if $$rr[0] eq 'OPT';
    $class = 'hh' if $$rr[0] eq 'HEAD'; # header
    $class = 'ff' if $$rr[0] eq 'FOOT'; # footer
    $class = 'cc' if $$rr[0] eq 'COMT'; # comments
    $text .= "<tr class=$class>\n";
    for my $d ( @$rr )
      {
      $c++;
      next if $c == 0;
      
      if( $d =~ s/^\[([^\]]+)\]// )
        {
        my $p = $1; # params
        my $o; # opts
        $o .= " align=right" if $p =~ />/;
        $o .= " width=$1" if $p =~ /(\d+%)/;
        $or[$c] = $o;
        #print STDERR "TABLE OPT: $p --> $o\n";
        }
      my $f = lc $1 if $d =~ s/\/([ip])$//; # [i]nt, [p]ercent
      $d = table_sum( $ar, $c ) if $d eq '(SUM)';
      $d = table_ave( $ar, $c ) if $d eq '(AVE)';
      $d = table_med( $ar, $c ) if $d eq '(MED)';
      
      $d = int $d if $f eq 'i';
      $d = $d > 0 ? sprintf "%.2f%%", $d : '' if $f eq 'p';
      
      $d = $r + 1 if $d eq '(ROW)';
      $text .= "<td $or[$c]>$d</td>";
      }
    $text .= "</tr>\n";
    }
  $text .= "</table>\n";
  return $text;
}

sub table_sum
{
  my $ar = shift;
  my $col = shift;
  my $sum = 0;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    $sum += $rr->[$col];
    }
  return $sum;
}

sub table_ave
{
  my $ar = shift;
  my $col = shift;
  my $sum = 0;
  my $cnt = 0;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    $sum += $rr->[$col];
    $cnt++;
    }
  return $cnt > 0 ? $sum / $cnt : 0;
}

sub table_med
{
  my $ar = shift;
  my $col = shift;
  my @sum;
  for my $rr ( @$ar )
    {
    next if $rr->[0] ne ''; # skip HEAD,FOOT
    push @sum, $rr->[$col];
    }
  @sum = sort { $b <=> $a } @sum;  
  return $sum[ @sum / 2 ];
}

##############################################################################

sub time_fmt
{
  my $data = shift;
  my $d = int($data / (24*60*60));
  my $h = int(($data % (24*60*60)) / (60*60));
  my $m = int(($data % (60*60)) / 60);        
  my $s = $data % 60;                 
  return sprintf "%6dd %02dh %02dm %02ds", $d, $h, $m, $s;
}

sub html_save
{
  my $file = shift;
  $file = "$html_dir/$file.html";
  open(my $o, '>' . $file) or die "$0: cannot save html file: $file\n";
  my $text = join '', $html_header, @_, $html_footer;
  my $time = scalar localtime();
  $text =~ s/\[TIME\]/$time/g;
  $text =~ s/\[ENV:([^\]]+)\]/$ENV{$1}/g;
  print $o $text;
  close($o);
  print STDERR "file $file written ok\n";
}

sub color_name
{
  my $s = shift;
  my $cs = $nam_color{ $s } || $s;
  # return $s unless $cs;
  my $c = $cs =~ s/\^(.)/"<font color=#" . $COLOR{ lc $1 } . ">"/gie;
  $cs .= "</font>" x $c;
  return "<font color=#ffffff>$cs</font>";
}

my $static_tr;

sub tr_class
{
  $static_tr = !$static_tr;
  $static_tr ? 'r1' : 'r2';
}

sub hash_max
{
  my $hr = shift;
  my $max_k = undef;
  my $max_v = undef;
  while( my ( $k, $v ) = each %$hr )
    {
    if( $max_v eq '' or $v > $max_v )
      {
      $max_k = $k;
      $max_v = $v;
      next;
      }
    }
  #print STDERR "$max_k, $max_v\n";
  return ( $max_k, $max_v );
}

sub hash_sum
{
  my $hr = shift;
  my $sum = 0;
  while( my ( $k, $v ) = each %$hr )
    {
    next if $k =~ /^!/;
    $sum += $v;
    }
  return $sum;
}

sub get_clan
{
  my $s = shift;
  my $c = '';
  $c = $1 if $s =~ /^\[([^\]]+)\]/;
  $c = $1 if $s =~ /\[([^\]]+)\]$/;
  $c = $1 if $s =~ /^([A-Z]{2,3})[:\-\|]/i;
  return uc "!$c";
}

###TEST#######################################################################

=pod

Axis   HELLS BELLS       0   1   0  0   0   0     0   125    0      0
                       4 0   1   0  0   0   1    0 0  125    0      0 
                       
Allies ValBo             2   4   0  1  33  17   360   800   66     31                       
                       0 1 133657 0 8 0 0 0 6 9 1 0 0 14 28 1 0 0 0 2 0 0 0 0 4 0 0 0 0 0 0 4 0 360 800 66 19 8 20 3

+++++++++
WS WeaponStats: 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5                       
Axis   [LUD]CADE   1   3   0  0  25   0   238   472    0     14 
               WS 2 1 
               3145756 (1100000000000000011100)
                         0  0 0 1 0 
                         3 14 0 0 0 
                         0  0 0 1 0 
                         0  0 0 1 0 
                 MP-40   3  8 1 0 1 
                 
                 238 472 0 
                 65 9 5                       
                 
Weapon     Acrcy Hits/Atts Kills Deaths Headshots
-------------------------------------------------
Colt     :                     0      1         0
MP-40    :  21.4    3/14       0      0         0
Thompson :                     0      1         0
Garand   :                     0      1         0
K43 Rifle:  37.5    3/8        1      0         1

Damage Given: 238     Team Damage: 0
Damage Recvd: 472

Rank: Schutze (14 XP)
Skills         Level/Points
---------------------------
Battle Sense   0 (9/20)
Covert Ops     0 (5/20)
                 
------------------------------------------------------------------------------

tova e po-skoro tehnicheska tema taka che ako na nqkoi ne mu e interesno da q 
propusne oshte sega

mai uspqh da razbera kakvo oznachava WeaponStats ot log-a, bih iskal da go 
post-na tuk v sluchai
che na nqkoi mu potrqbva ili mu e interesno

ta v loga nakraq na vsqka igra se poqvqva tova (t.e. podobni redove ):

WeaponStats: 2 1 3145756 0 0 0 1 0 3 14 0 0 0 0 0 0 1 0 0 0 0 1 0 3 8 1 0 1 238 472 0 65 9 5

i sega edno po edno:

2 -- nomer na client-a (player)
1 -- tova mai e za kolko rounds sa tezi danni
3145756 -- bitmap s izpolzvanite oryjiq (binarno e: 1100000000000000011100) t.e. 
           izpolzvani sa 5 oryjiq (colt,mp40,thompson,garand,k43) sledvat grupi 
           ot po 5 chisla za vsqko polzvano oryjie i 
           oznachavat: hits, shots, kills, deaths, headshots

t.e. gornite chisla predstavlqvat tova:

Weapon Acrcy Hits/Atts Kills Deaths Headshots
-------------------------------------------------
Colt : 0 1 0
MP-40 : 21.4 3/14 0 0 0
Thompson : 0 1 0
Garand : 0 1 0
K43 Rifle: 37.5 3/8 1 0 1

sledvashtite 3 chisla sa:

Damage Given: 238
Damage Recvd: 472
Team Damage: 0

sled tova pak ima bitmap na izpolzvanite abilities (clasove)
65 -- binarno e 1000001 i levelite za tezi abilities:

Skills Level/Points
---------------------------
Battle Sense 0 (9/20)
Covert Ops 0 (5/20)

Rank-a mai samo se sybira, t.e. e 14

voila

btw: thanx na Lg-Badluck che mi obyrna vnimanie na komandata /statsdump!

cheers! 


=cut

###EOF########################################################################

